'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.get = get;
exports.transformOptions = transformOptions;
var noop = function noop() {};

function get() {
  return {
    ns: 'translation',
    fallbackLng: 'dev',
    fallbackNS: false, // string or array of namespaces

    whitelist: false, // array with whitelisted languages
    load: 'all', // | currentOnly | languageOnly
    preload: false, // array with preload languages

    saveMissing: false, // enable to send missing values
    saveMissingTo: 'fallback', // 'current' || 'all'
    missingKeyHandler: false, // function(lng, ns, key, fallbackValue) -> override if prefer on handling

    postProcess: false, // string or array of postProcessor names
    returnNull: true, // allows null value as valid translation
    returnEmptyString: true, // allows empty string value as valid translation
    returnObjects: false,
    returnedObjectHandler: noop, // function(key, value, options) triggered if key returns object but returnObjects is set to false
    parseMissingKeyHandler: noop, // function(key) parsed a key that was not found in t() before returning
    appendNamespaceToMissingKey: false,
    overloadTranslationOptionHandler: function overloadTranslationOptionHandler(args) {
      return { defaultValue: args[1] };
    },

    interpolation: {
      escapeValue: false,
      prefix: '{{',
      suffix: '}}',
      // prefixEscaped: '{{',
      // suffixEscaped: '}}',
      // unescapeSuffix: '',
      unescapePrefix: '-',

      nestingPrefix: '$t(',
      nestingSuffix: ')',
      // nestingPrefixEscaped: '$t(',
      // nestingSuffixEscaped: ')',
      defaultVariables: undefined // object that can have values to interpolate on - extends passed in interpolation data
    }

  };
}

// TODO: move this defaults to individual modules
// backend: {
//   loadPath: '/locales/{{lng}}/{{ns}}.json',
//   addPath: 'locales/add/{{lng}}/{{ns}}',
//   allowMultiLoading: false
// },
//
// cache: {
//   enabled: false,
//   prefix: 'i18next_res_',
//   expirationTime: 7*24*60*60*1000
// },
//
// detection: {
//   order: ['querystring', 'cookie', 'localStorage', 'navigator'],
//   lookupQuerystring: 'lng',
//   lookupCookie: 'i18next',
//   lookupLocalStorage: 'i18nextLng',
//
//   // cache user language
//   caches: ['localStorage']
//   //cookieMinutes: 10,
//   //cookieDomain: 'myDomain'
// }

function transformOptions(options) {
  // create namespace object if namespace is passed in as string
  if (typeof options.ns === 'string') options.ns = [options.ns];
  if (typeof options.fallbackLng === 'string') options.fallbackLng = [options.fallbackLng];
  if (typeof options.fallbackNS === 'string') options.fallbackNS = [options.fallbackNS];

  return options;
}